<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="modal-header">
  <h4
    class="modal-title"
    id="modal-basic-title"
    [innerText]="performedAction | actionName">
  </h4>
  <button
    type="button"
    class="btn-close"
    [title]="commonMessages.CLOSE"
    (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
  </button>
</div>

<div class="modal-body">
  <form class="ls-form">

    <div
      *ngIf="showAnnotations"
      class="form-group">
      <label
        for="publicAnnotation"
        [ngClass]="{'required': isPublicAnnotationMandatory()}"
        [innerText]="commonMessages.PUBLIC_ANNOTATION">
      </label>
      <textarea
        id="publicAnnotation"
        class="form-control"
        [required]="isPublicAnnotationMandatory()"
        [(ngModel)]="publicAnnotation"
        [maxlength]="annotationMaxSize"
        name="publicAnnotation"
        rows="3">
      </textarea>
    </div>

    <div
      *ngIf="showAnnotations"
      class="form-group">
      <label
        for="privateAnnotation"
        [innerText]="commonMessages.PRIVATE_ANNOTATION">
      </label>
      <textarea
        id="privateAnnotation"
        class="form-control"
        [(ngModel)]="privateAnnotation"
        [maxlength]="annotationMaxSize"
        name="privateAnnotation"
        rows="3">
      </textarea>
    </div>

    <div
      *ngIf="showCustomSignatureField"
      class="form-group">
      <label
        for="customSignatureField"
        [innerText]="commonMessages.CUSTOM_SIGNATURE_FIELD">
      </label>
      <textarea
        id="customSignatureField"
        class="form-control"
        [(ngModel)]="customSignatureField"
        rows="3">
      </textarea>
    </div>

    <app-metadata-form
      [tenantId]="tenant.id"
      [(folders)]="folders"
      [performedAction]="performedAction"
      [(validationMetadataFormValid)]="validationMetadataFormValid"
      [(rejectionMetadataFormValid)]="rejectionMetadataFormValid">
    </app-metadata-form>

    <div
      *ngIf="folders.length > 1"
      class="progress">
      <div
        class="text-center position-absolute progress-bar-text m-0 p-0"
        [innerText]="(numberOfFailedTasks + numberOfSuccessfulTasks) + ' / ' + numberOfTasks">
      </div>
      <div
        [style.width.%]="successfulTasksProgressBarPercentage"
        class="progress-bar progress-bar-striped bg-success progress-bar-animated"
        role="progressbar">
      </div>
      <div
        [style.width.%]="failedTasksProgressBarPercentage"
        class="progress-bar progress-bar-striped bg-danger progress-bar-animated"
        role="progressbar">
      </div>
    </div>

    <ng-container *ngIf="hasSignature && useLibersign === false">
      <app-fortify-certificates-selector
        (certChosen)="onCertificateChosen($event)"
        (signatureResult)="onSignatureResult($event)"
        [dataToSign]="dataToSign">
      </app-fortify-certificates-selector>
    </ng-container>

    <ng-container *ngIf="hasSignature && useLibersign === true">
      <ls-libersign
        (sign)="onCertificateChosen($event)"
        (signed)="onSignatureResult($event)"
        (cancel)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)"
        [dataToSign]="dataToSign"
        [valid]="isFormValid() ? 'true' : 'false'"
        [updateUrl]="libersignUpdateUrl"
        [appletUrl]="libersignAppletUrl">
      </ls-libersign>
    </ng-container>

    <div
      *ngIf="performedAction === actionEnum.Ipng"
      class="form-group">
      <app-ipng-form
        [publicAnnotation]="publicAnnotation"
        [privateAnnotation]="privateAnnotation"
        (created)="finalizeAction($event)">
      </app-ipng-form>
    </div>

  </form>
</div>

<div *ngIf="shouldDisplayStandardActionButton()" class="modal-footer">
  <button
    ls-button-cancel
    (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
  </button>

  <button
    ls-button [style]="styleEnum.NORMAL"
    (click)="performAll()"
    [disabled]="(performedAction === actionEnum.Signature && !fortifyCertificate && !libersignCertificate) || !isFormValid()"
    [processing]="isProcessing"
    [text]="commonMessages.VALIDATE">
  </button>
</div>
